%global version 0.11.2
%global reponame WasmEdge
%global capi_soname 0
%global capi_version 0.0.1

Name:    wasmedge
Version: %{version}
Release: 1%{?dist}
Summary: High performance WebAssembly Virtual Machine
# The entire source code is ASL 2.0 except LICENSE.spdx which is CC0
License: ASL 2.0 and CC0
URL:     https://github.com/%{reponame}/%{reponame}
Source0: %{url}/releases/download/%{version}/%{reponame}-%{version}-src.tar.gz
BuildRequires: boost-devel
BuildRequires: cmake
BuildRequires: gcc-c++
BuildRequires: gcc-toolset-10-toolchain
BuildRequires: git
BuildRequires: lld-devel
BuildRequires: llvm-devel
BuildRequires: ninja-build
BuildRequires: spdlog-devel
Requires:      lld
Requires:      llvm
Requires:      spdlog
# Currently wasmedge could only be built on specific arches
ExclusiveArch: x86_64 aarch64
Provides: %{reponame} = %{version}-%{release}
Provides: bundled(blake3) = 1.2.0
Provides: bundled(wasi-cpp-header) = 0.0.1
Provides: wasm-library

%description
High performance WebAssembly Virtual Machine

%package devel
Summary: %{reponame} development files
Requires: %{name}%{?_isa} = %{version}-%{release}
Provides: %{reponame}-devel = %{version}-%{release}

%description devel
This package contains necessary header files for %{reponame} development.

%prep
%autosetup -n %{name}
[ -f VERSION ] || echo -n %{version} > VERSION

%build
source /opt/rh/gcc-toolset-10/enable
%cmake -GNinja -DCMAKE_BUILD_TYPE=RelWithDebInfo -DBUILD_SHARED_LIBS=OFF -DWASMEDGE_BUILD_TESTS=OFF
%cmake_build

%install
%cmake_install
mv %{buildroot}%{_libdir}/%{name}/lib%{name}Plugin%{reponame}Process.so %{buildroot}%{_libdir}/%{name}/lib%{name}Plugin%{reponame}Process.so.%{version}
ln -s lib%{name}Plugin%{reponame}Process.so.%{version} %{buildroot}%{_libdir}/%{name}/lib%{name}Plugin%{reponame}Process.so

%files
%license LICENSE LICENSE.spdx
%doc Changelog.md README.md SECURITY.md
%{_bindir}/wasmedge
%{_bindir}/wasmedgec
%{_libdir}/lib%{name}.so.%{capi_version}
%{_libdir}/lib%{name}.so.%{capi_soname}
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/lib%{name}Plugin%{reponame}Process.so.%{version}

%files devel
%dir %{_includedir}/%{name}
%{_includedir}/%{name}/enum.inc
%{_includedir}/%{name}/enum_configure.h
%{_includedir}/%{name}/enum_errcode.h
%{_includedir}/%{name}/enum_types.h
%{_includedir}/%{name}/int128.h
%{_includedir}/%{name}/version.h
%{_includedir}/%{name}/wasmedge.h
%{_libdir}/lib%{name}.so
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/lib%{name}Plugin%{reponame}Process.so

%changelog
* Wed Nov 16 2022 dm4 <dm4@secondstate.io> 0.11.2-1
- Release 0.11.2
